///////////////////////////////////////////////////////////////////////////////
//
// Copyright 2007, Erik Vidholm
//
//
//   This file is part of WISH.
//
//   WISH is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   WISH is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with WISH.  If not, see <http://www.gnu.org/licenses/>.
//
///////////////////////////////////////////////////////////////////////////////

uniform vec3 totalExtent;

varying vec3 raystart;
varying vec3 raydir;

vec3 totex(vec3 v) {
  return vec3(1,-1,-1)*v/totalExtent+0.5;
}

void main() {
  raystart = totex(gl_Vertex.xyz);
  //raystart = gl_MultiTexCoord0.xyz;
  vec4 campos = gl_ModelViewMatrixInverse*vec4(0,0,0,1);
  raydir = raystart-totex(campos.xyz);
  
  gl_Position = ftransform();
}
