///////////////////////////////////////////////////////////////////////////////
//
// Copyright 2007, Erik Vidholm
//
//
//   This file is part of WISH.
//
//   WISH is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   WISH is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with WISH.  If not, see <http://www.gnu.org/licenses/>.
//
///////////////////////////////////////////////////////////////////////////////

uniform sampler3D volumeTexture;
uniform sampler3D volumeTexture2;
uniform float wl_width;
uniform float wl_level;

varying vec3 texcoord;

vec4 windowLevel(vec4 arg, float wlw, float wll) {
  float temp = (arg.a-wll)/wlw + 0.5;
  vec4 ret;
  ret.rgb = (temp/max(arg.a, 0.1))*arg.rgb;
  ret.a = max(0.8, temp);
  return ret;
}

float windowLevel(float arg, float wlw, float wll) {
  return (arg-wll)/wlw + 0.5;
}

void main() {
  
  // fetch texture
  vec4 col1 = texture3D(volumeTexture, texcoord);  // original
  vec4 col2 = texture3D(volumeTexture2, texcoord); // overlay
  
  // red if overlay is larger than 0
  vec4 col = col1;
  if( col2.r>0 )
    col.rgb = vec3(col2.r, 0, 0);
  
  // set color
  gl_FragColor = windowLevel(col, wl_width, wl_level);  
  
}
