///////////////////////////////////////////////////////////////////////////////
//
// Copyright 2007, Erik Vidholm
//
//
//   This file is part of WISH.
//
//   WISH is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   WISH is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with WISH.  If not, see <http://www.gnu.org/licenses/>.
//
///////////////////////////////////////////////////////////////////////////////

#ifndef _WISH_HH_
#define _WISH_HH_

// include the most important standards
#include <iostream>
#include <cmath>
#include <ctime>
#include <cstdio>
#include <cstdlib>
#include <cctype>
#include <iomanip>
#include <sstream>
#include <fstream>
#include <typeinfo>
#include <limits>
#include <cassert>
#include <memory>
#include <string>
#include <vector>
#include <list>
#include <map>
#include <queue>
#include <algorithm>
#include <bitset>

// windows stuff
#if defined (WIN32) || defined (__WIN32__)
#include <windows.h>
#endif // windows stuff

// convenient bugtrackers
#define BUGMACRO() fprintf(stderr, "Line %d in file %s\n", __LINE__, __FILE__)
#define BUGMACRO_STDOUT() fprintf(stdout, "Line %d in file %s\n", __LINE__, __FILE__)


namespace wish {
  
  // namespaces
  using namespace std;
  
  // typedefs
  typedef unsigned char  byte;
  typedef unsigned char  uint8;
  typedef unsigned short uint16;
  typedef unsigned int   uint32;
  typedef char           int8;
  typedef short          int16;
  typedef int            int32;
  typedef float WISH_FLOAT;

  namespace constants {
    // useful constants
    const double eps = 1e-12;   
    const double eps3 = 1e-3;      
    const double eps6 = 1e-6;      
    const double eps9 = 1e-9;
    const double inf = 1e12;
    const double pi = 3.1415926535897932384626433832795;
    const double half_pi = pi/2.0;
  }
  
}

#endif
