///////////////////////////////////////////////////////////////////////////////
//
// Copyright 2007, Erik Vidholm
//
//
//   This file is part of WISH.
//
//   WISH is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   WISH is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with WISH.  If not, see <http://www.gnu.org/licenses/>.
//
///////////////////////////////////////////////////////////////////////////////

#ifndef _WISH_BOUNDING_BOX_HH_
#define _WISH_BOUNDING_BOX_HH_

#include "wish.hh"
#include "wishutil.hh"
#include "wishLinalg.hh"

namespace wish {
  
  class BoundingBox {
  public:
    
    //! pointer typedef
    typedef auto_ptr< BoundingBox > Pointer;
    
    Vec3i start;
    Vec3i stop;
    
    Vec3i getSize() const {
      return Vec3i(stop.x-start.x+1,
		   stop.y-start.y+1,
		   stop.z-start.z+1);
    }
    
    int getTotalSize() const {
      Vec3i tmp = this->getSize();
      return tmp.x * tmp.y * tmp.z;
    }
    
    BoundingBox(const Vec3i &_start=Vec3i(0,0,0),
		const Vec3i &_stop=Vec3i(0,0,0)) : 
      start(_start), 
      stop(_stop)  {}
  };
  
} // end namespace wish

#endif
