///////////////////////////////////////////////////////////////////////////////
//
// Copyright 2007, Erik Vidholm, Per Sundqvist
//
//
//   This file is part of WISH.
//
//   WISH is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   WISH is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with WISH.  If not, see <http://www.gnu.org/licenses/>.
//
///////////////////////////////////////////////////////////////////////////////

#ifndef _WISH_GVF_CONJUGATE_GRADIENTS_HH_
#define _WISH_GVF_CONJUGATE_GRADIENTS_HH_

#include "wishGVFSolverUtil.hh"

namespace wishGVF {

  //
  // Preconditioned conjugate gradients
  int pcg(float *u,                               // gridfunction
	  float *rhs,                             // right hand side
	  float *vc,                              // variable diagonal
	  float *r, float *p, float *w, float *v, // vectors used in PCG
	  float MU, float AR2,                    // coefficients to operator
	  int X, int Y, int Z,                    // sizes
	  float eps,                              // termination criterion
	  float *a,                               // vector for preconditioner
	  float omega);                           // parameter for preconditioner
  
  //
  // Application of preconditioner
  void appl_precond(float *v,
		    float *r,
		    float *vc,
		    float *a,
		    float MU, float AR2,
		    int X, int Y, int Z,
		    float omega);
  
}

#endif
