///////////////////////////////////////////////////////////////////////////////
//
// Copyright 2007, Erik Vidholm
//
//
//   This file is part of WISH.
//
//   WISH is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   WISH is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with WISH.  If not, see <http://www.gnu.org/licenses/>.
//
///////////////////////////////////////////////////////////////////////////////

#ifndef _WISH_VTK_FILE_READER_HH_
#define _WISH_VTK_FILE_READER_HH_

#include "wishImageFileReader.hh"

namespace wish {
  
  //! VTKFileReader
  class VTKFileReader : public ImageFileReader {
    
  protected:
    //! flag that is true if data is in binary mode, otherwise ascii
    bool m_binary;
    
    //! reads the header and stores the properties in the info struct
    bool readHeader();
    
    //! reads the data
    bool readData();
    
  public:
    //! constructor
    VTKFileReader() {}
    
    //! print self
    void printSelf() const {
      cout << "VTKFileReader";
    }
    
  };
  
}

#endif
