///////////////////////////////////////////////////////////////////////////////
//
// Copyright 2007, Erik Vidholm
//
//
//   This file is part of WISH.
//
//   WISH is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   WISH is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with WISH.  If not, see <http://www.gnu.org/licenses/>.
//
///////////////////////////////////////////////////////////////////////////////

// the texture matrix and its inverse
uniform mat4 textureMatrix;
uniform mat4 textureMatrixInverse;

// ray start
varying vec3 rayStart;

// ray dir
varying vec3 rayDir;

void main() {
  rayStart = (textureMatrix*gl_Vertex).xyz;
  rayDir = 
    rayStart-(textureMatrix*gl_ModelViewMatrixInverse*vec4(0,0,0,1)).xyz;
  gl_Position = ftransform(); 
}
