///////////////////////////////////////////////////////////////////////////////
//
// Copyright 2007, Erik Vidholm
//
//
//   This file is part of WISH.
//
//   WISH is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   WISH is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with WISH.  If not, see <http://www.gnu.org/licenses/>.
//
///////////////////////////////////////////////////////////////////////////////

#ifndef __WISH_H3D_BILATERALFILTER_HH__
#define __WISH_H3D_BILATERALFILTER_HH__

#include "wishH3DFilterObject.hh"

using namespace H3D;

namespace wishH3D {
  class WISHH3D_API BilateralFilter : public FilterObject {
  public:
    typedef FilterObject BaseClass;
    
    /// Constructor.
    BilateralFilter();
    
    // index of the input image
    auto_ptr<SFInt32> inputIndex;
    
    // sigma spatial
    auto_ptr<SFFloat> sigmaSpatial;
    
    // sigma range
    auto_ptr<SFFloat> sigmaRange;
    
    /// The H3DNodeDatabase for this node.
    static H3DNodeDatabase database;

  protected:
    // execute the filter
    virtual wish::ImageObject* execute();
  };
}

#endif
