///////////////////////////////////////////////////////////////////////////////
//
// Copyright 2007, Erik Vidholm
//
//
//   This file is part of WISH.
//
//   WISH is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   WISH is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with WISH.  If not, see <http://www.gnu.org/licenses/>.
//
///////////////////////////////////////////////////////////////////////////////

#ifndef _WISH_H3D_COLOR_TRANSFER_FUNCTION_HH_
#define _WISH_H3D_COLOR_TRANSFER_FUNCTION_HH_

#include "SFNode.h"
#include "MFNode.h"
#include "DependentNodeFields.h"
#include "wishH3DTransferFunction.hh"
#include "MFColor.h"

using namespace H3D;

namespace wishH3D {
  
  class WISHH3D_API ColorTransferFunction : public TransferFunction {
  public:
    
    // the interface
    static H3DNodeDatabase database;
    
    // constructor
    ColorTransferFunction();  
    
    // evaluate functions
    virtual H3DFloat evaluate(const H3DFloat &arg) const {
      return 0.0f;
    }
    virtual RGB evaluateRGB(const H3DFloat &arg) const;
    
    // samples
    auto_ptr<MFFloat> xsamples;
    auto_ptr<MFColor> ysamples;
  };
  
}
#endif
