///////////////////////////////////////////////////////////////////////////////
//
// Copyright 2007, Erik Vidholm
//
//
//   This file is part of WISH.
//
//   WISH is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   WISH is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with WISH.  If not, see <http://www.gnu.org/licenses/>.
//
///////////////////////////////////////////////////////////////////////////////

#ifndef __WISH_H3D_COMPARESEGMENTATIONS_HH__
#define __WISH_H3D_COMPARESEGMENTATIONS_HH__

#include "X3DChildNode.h"
#include "SFBool.h"

#include "wishH3DVolumeChild.hh"

using namespace H3D;

namespace wishH3D {
  class WISHH3D_API CompareSegmentations : 
    public X3DChildNode, public VolumeChild {
  public:
    typedef X3DChildNode BaseClass;
    
    struct Compare : public TypedField<SFString, SFBool> {
      virtual void update();
    };
    friend struct Compare;
    
    /// Constructor
    CompareSegmentations();
    
    // executes the comparison
    auto_ptr<Compare> compare;
    
    // output index
    auto_ptr<SFInt32> trueDelineationIndex;
    auto_ptr<SFInt32> delineationIndex;
    
    /// The H3DNodeDatabase for this node.
    static H3DNodeDatabase database;
    
  protected:
  };
}

#endif
