///////////////////////////////////////////////////////////////////////////////
//
// Copyright 2007, Erik Vidholm
//
//
//   This file is part of WISH.
//
//   WISH is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   WISH is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with WISH.  If not, see <http://www.gnu.org/licenses/>.
//
///////////////////////////////////////////////////////////////////////////////

#ifndef __WISH_H3D_SFTFTEXTURE_HH__
#define __WISH_H3D_SFTFTEXTURE_HH__

#include "Appearance.h"
#include "PixelTexture.h"
#include "wishH3DTransferFunction.hh"
#include "wishH3DColorTransferFunction.hh"
#include "wishH3D.hh"

using namespace H3D;

namespace wishH3D {
  
  class WISHH3D_API SFTFTexture : 
    public TypedField<TypedSFNode<PixelTexture>, void, Types<SFTransferFunction, SFTransferFunction, SFTransferFunction, SFTransferFunction> > {
  public:
    static const int NTEX;
    SFTFTexture();
    virtual void update();
  };
  
}

#endif
