///////////////////////////////////////////////////////////////////////////////
//
// Copyright 2007, Erik Vidholm
//
//
//   This file is part of WISH.
//
//   WISH is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   WISH is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with WISH.  If not, see <http://www.gnu.org/licenses/>.
//
///////////////////////////////////////////////////////////////////////////////

#include "wishH3DVolumeGraphics.hh"

using namespace H3D;

namespace wishH3D {
  
  // Add this node to the H3DNodeDatabase system.
  H3DNodeDatabase 
  VolumeGraphics::database( "wishH3DVolumeGraphics", 
			    &(newInstance<VolumeGraphics>), 
			    typeid( VolumeGraphics ),
			    &Shape::database );
  
  namespace VolumeGraphicsInternals {
    FIELDDB_ELEMENT( VolumeGraphics, volume, INPUT_OUTPUT );
  }
  
  /// Constructor.
  VolumeGraphics::VolumeGraphics() {
    this->type_name = "VolumeGraphics";
    database.initFields( this );
    
    WISH_H3D_CREATE_START();
    
    WISH_H3D_CREATE_STOP();
    
  }
    
}
